> Delete blockquotes like this one from the final README, they are here to help
> example developers and do not form part of what should be provided in the
> final published example set.

# `Functionality` Examples

A collection of crates that provide examples of `functionality` when working
with the Gotham web framework.

> For specific areas of functionality a new directory under `examples` is
> created, using this README template as a basis to describe the provided
> examples.

## Ordering

We recommend reviewing our `functionality` examples in the order shown below:

1. [Name](name) - Shows how to do something with `functionality`

> Choose example names that describe functionality. The starting example being
> called "Introduction" is a pattern that other areas follow but is not
> a hard requirement.
>
> Do not use words like "simple", "basic", "intermediate" or "advanced" which 
> are subjective and may make the example seem unaccessible to some developers.

## Help

You can get help for the Gotham web framework at:

* [The Gotham web framework website](https://gotham.rs)
* [Gotham web framework API documentation](https://docs.rs/gotham/)
* [Gitter chatroom](https://gitter.im/gotham-rs/gotham)
* [Twitter](https://twitter.com/gotham_rs)

## License

Licensed under your option of:

* [MIT License](../LICENSE-MIT)
* [Apache License, Version 2.0](../LICENSE-APACHE)

## Community

The following policies guide participation in our project and our community:

* [Code of conduct](../../CODE_OF_CONDUCT.md)
* [Contributing](../../CONTRIBUTING.md)
